package Cm;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;

class InternalTransaction 
{
  public static final byte closed = 0;
  public static final byte pending = 1;
  public static final byte terminated = 2;
  
  private int    _state;
  private String _name;
  private long   _id;

  public InternalTransaction (long id, String name)
      {
        _id = id ;
        _state = pending;
        _name = name;
      }

  public synchronized void set_state (byte new_state)
      {
        _state = new_state;
        notifyAll ();
      }

  public synchronized void do_wait ()
      {
        while (_state == pending)
          try 
            { 
              wait (1000);
              //System.out.println ("after wait on transaction " + _id);
            }
          catch (InterruptedException e) 
            {
            } 
      }
}


public class Transaction
{
  public static final byte closed = 0;
  public static final byte pending = 1;
  public static final byte terminated = 2;
  static Hashtable dicos;

  public static int open (String s)
      {
        InternalTransaction transaction;

        Long lvalue = new Long (System.currentTimeMillis ()); 
        int value = lvalue.intValue ();
        
        transaction = new InternalTransaction (value, s);
        
        if (dicos == null)
          {
            dicos = new Hashtable ();
          }
        
        dicos.put (String.valueOf (value), transaction);
          //System.out.println ("value = " + value);
        return (value);
      }
  
  public static boolean close (int id)
      {
        if (dicos == null) return false;
        InternalTransaction transaction = (InternalTransaction) 
            dicos.get (String.valueOf (id));

        if (transaction == null) return false;
        transaction.set_state (closed);
        return true;
      }

  public static boolean terminate (int id)
      {
        if (dicos == null) return false;
        InternalTransaction transaction = (InternalTransaction) 
            dicos.get (String.valueOf (id));

        if (transaction == null) return false;
        transaction.set_state (terminated);
        return true;
      }

  public static boolean restart (int id)
      {
        if (dicos == null) return false;
        InternalTransaction transaction = (InternalTransaction) 
            dicos.get (String.valueOf (id));

        if (transaction == null) return false;

        transaction.set_state (pending);
        return true;
      }
  
  public static void do_wait (int id)
      {
        if (dicos == null) return;

        InternalTransaction transaction = (InternalTransaction) 
            dicos.get ( String.valueOf (id));

        if (transaction == null) return;
        transaction.do_wait ();
      }
}


class CmThread extends Thread
{
  public Transaction cm_transaction;
  public int _id;
  
  public CmThread (int id)
      {
        _id = id;
        start ();
      }
  
  public void run ()
      {
        try 
          {
            sleep (500);
            /*
            System.out.println ("I am :"+_id);
            sleep (500);
            System.out.println ("I am :"+_id);
            sleep (500);
            System.out.println ("I am :"+_id);
            */
          } 
        catch (InterruptedException e) {} 
        
        cm_transaction.terminate (_id);
      }
}
